Index: /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/CorrelationMatrixContent.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/CorrelationMatrixContent.cs	(revision 13508)
+++ /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/CorrelationMatrixContent.cs	(revision 13508)
@@ -0,0 +1,65 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Problems.DataAnalysis;
+
+namespace HeuristicLab.DataPreprocessing {
+  [Item("Feature Correlation Matrix", "Represents the feature correlation matrix.")]
+  public class CorrelationMatrixContent : Item, IViewChartShortcut {
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Gradient; }
+    }
+
+    private PreprocessingContext Context { get; set; }
+    private ITransactionalPreprocessingData PreprocessingData {
+      get { return Context.Data; }
+    }
+
+    public DataAnalysisProblemData ProblemData {
+      get {
+        return (DataAnalysisProblemData)Context.CreateNewProblemData();
+        //var creator = new ProblemDataCreator(Context);
+        //return (DataAnalysisProblemData)creator.CreateProblemData();
+      }
+    }
+
+    public CorrelationMatrixContent(PreprocessingContext context) {
+      Context = context;
+    }
+
+    public CorrelationMatrixContent(CorrelationMatrixContent original, Cloner cloner)
+      : base(original, cloner) {
+      Context = original.Context;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new CorrelationMatrixContent(this, cloner);
+    }
+
+    public event DataPreprocessingChangedEventHandler Changed {
+      add { PreprocessingData.Changed += value; }
+      remove { PreprocessingData.Changed -= value; }
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/DataCompletenessChartContent.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/DataCompletenessChartContent.cs	(revision 13508)
+++ /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/DataCompletenessChartContent.cs	(revision 13508)
@@ -0,0 +1,29 @@
+﻿using System.Drawing;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.DataPreprocessing {
+  [Item("DataCompletenessChart", "Represents a datacompleteness chart.")]
+
+  public class DataCompletenessChartContent : Item, IViewChartShortcut {
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.EditBrightnessContrast; }
+    }
+
+    //public DataGridLogic DataGridLogic { get; private set; }
+    public SearchLogic SearchLogic { get; private set; }
+
+    public DataCompletenessChartContent(SearchLogic searchLogic) {
+      SearchLogic = searchLogic;
+    }
+
+    public DataCompletenessChartContent(DataCompletenessChartContent content, Cloner cloner)
+      : base(content, cloner) {
+      SearchLogic = content.SearchLogic;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new DataCompletenessChartContent(this, cloner);
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/DataGridContent.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/DataGridContent.cs	(revision 13508)
+++ /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/DataGridContent.cs	(revision 13508)
@@ -0,0 +1,160 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Drawing;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.DataPreprocessing {
+
+  [Item("DataGrid", "Represents a data grid.")]
+  public class DataGridContent : Item, IViewShortcut, IDataGridContent {
+
+    public ITransactionalPreprocessingData PreProcessingData { get; private set; }
+
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Table; }
+    }
+
+    public ManipulationLogic ManipulationLogic { get; private set; }
+    public FilterLogic FilterLogic { get; private set; }
+
+    public int Rows {
+      get {
+        return PreProcessingData.Rows;
+      }
+      set {
+        //does nothing
+      }
+    }
+
+    public int Columns {
+      get {
+        return PreProcessingData.Columns;
+      }
+      set {
+        //does nothing
+      }
+    }
+
+    public IEnumerable<string> ColumnNames {
+      get {
+        return PreProcessingData.VariableNames;
+      }
+      set {
+
+      }
+    }
+
+    public IEnumerable<string> RowNames {
+      get {
+        return Enumerable.Range(1, Rows).Select(n => n.ToString());
+      }
+      set {
+        throw new NotSupportedException();
+      }
+    }
+
+    public bool SortableView {
+      get {
+        return true;
+      }
+      set {
+        throw new NotSupportedException();
+      }
+    }
+
+    public bool ReadOnly {
+      get { return false; }
+    }
+
+
+    public IDictionary<int, IList<int>> Selection {
+      get { return PreProcessingData.Selection; }
+      set { PreProcessingData.Selection = value; }
+    }
+
+
+    public DataGridContent(ITransactionalPreprocessingData preProcessingData, ManipulationLogic theManipulationLogic, FilterLogic theFilterLogic) {
+      ManipulationLogic = theManipulationLogic;
+      FilterLogic = theFilterLogic;
+      PreProcessingData = preProcessingData;
+    }
+
+    public DataGridContent(DataGridContent dataGridContent, Cloner cloner)
+      : base(dataGridContent, cloner) {
+
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new DataGridContent(this, cloner);
+    }
+
+    public void DeleteRows(IEnumerable<int> rows) {
+      PreProcessingData.DeleteRowsWithIndices(rows);
+    }
+
+    public void DeleteColumn(int column) {
+      PreProcessingData.DeleteColumn(column);
+    }
+
+    public bool Validate(string value, out string errorMessage, int columnIndex) {
+      return PreProcessingData.Validate(value, out errorMessage, columnIndex);
+    }
+
+    public string GetValue(int rowIndex, int columnIndex) {
+      return PreProcessingData.GetCellAsString(columnIndex, rowIndex);
+    }
+
+    public bool SetValue(string value, int rowIndex, int columnIndex) {
+      return PreProcessingData.SetValue(value, columnIndex, rowIndex);
+    }
+
+    public event DataPreprocessingChangedEventHandler Changed {
+      add { PreProcessingData.Changed += value; }
+      remove { PreProcessingData.Changed -= value; }
+    }
+
+
+    #region unused stuff/not implemented but necessary due to IStringConvertibleMatrix
+#pragma warning disable 0067
+    // Is not used since DataGridContentView overrides dataGridView_CellValidating and uses 
+    // DataGridLogic#Validate(string value, out string errorMessage, int columnIndex)
+    public bool Validate(string value, out string errorMessage) {
+      errorMessage = string.Empty;
+      return true;
+    }
+
+    public event EventHandler ColumnsChanged;
+    public event EventHandler RowsChanged;
+    public event EventHandler ColumnNamesChanged;
+    public event EventHandler RowNamesChanged;
+    public event EventHandler SortableViewChanged;
+    public event EventHandler<EventArgs<int, int>> ItemChanged;
+    public event EventHandler Reset;
+
+#pragma warning restore 0067
+    #endregion
+
+  }
+}
Index: /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/FilterContent.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/FilterContent.cs	(revision 13508)
+++ /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/FilterContent.cs	(revision 13508)
@@ -0,0 +1,70 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.DataPreprocessing.Filter;
+
+namespace HeuristicLab.DataPreprocessing {
+  [Item("Filter", "Represents the filter grid.")]
+  public class FilterContent : Item, IViewShortcut {
+
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Filter; }
+    }
+
+    private ICheckedItemCollection<IFilter> filters = new CheckedItemCollection<IFilter>();
+
+    public FilterLogic FilterLogic { get; private set; }
+
+    public ICheckedItemCollection<IFilter> Filters {
+      get {
+        return this.filters;
+      }
+      set {
+        this.filters = value;
+      }
+    }
+
+    private bool isAndCombination = true;
+    public bool IsAndCombination {
+      get {
+        return this.isAndCombination;
+      }
+      set {
+        this.isAndCombination = value;
+      }
+    }
+
+    public FilterContent(FilterLogic filterLogic) {
+      FilterLogic = filterLogic;
+    }
+
+    protected FilterContent(FilterContent content, Cloner cloner)
+      : base(content, cloner) {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new FilterContent(this, cloner);
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/HistogramContent.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/HistogramContent.cs	(revision 13508)
+++ /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/HistogramContent.cs	(revision 13508)
@@ -0,0 +1,74 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Drawing;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.DataPreprocessing {
+  [Item("Histogram", "Represents the histogram grid.")]
+  public class HistogramContent : PreprocessingChartContent {
+
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Statistics; }
+    }
+    private const int MAX_DISTINCT_VALUES_FOR_CLASSIFCATION = 20;
+
+    private int classifierVariableIndex = 0;
+
+    public int ClassifierVariableIndex {
+      get { return this.classifierVariableIndex; }
+      set { this.classifierVariableIndex = value; }
+    }
+    public bool IsDetailedChartViewEnabled { get; set; }
+
+
+    public HistogramContent(IFilteredPreprocessingData preprocessingData)
+      : base(preprocessingData) {
+      AllInOneMode = false;
+    }
+
+    public HistogramContent(HistogramContent content, Cloner cloner)
+      : base(content, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new HistogramContent(this, cloner);
+    }
+
+    public IEnumerable<string> GetVariableNamesForHistogramClassification() {
+      List<string> doubleVariableNames = new List<string>();
+
+      //only return variable names from type double
+      for (int i = 0; i < PreprocessingData.Columns; ++i) {
+        if (PreprocessingData.VariableHasType<double>(i)) {
+          double distinctValueCount = PreprocessingData.GetValues<double>(i).GroupBy(x => x).Count();
+          bool distinctValuesOk = distinctValueCount <= MAX_DISTINCT_VALUES_FOR_CLASSIFCATION;
+          if (distinctValuesOk)
+            doubleVariableNames.Add(PreprocessingData.GetVariableName(i));
+        }
+      }
+      return doubleVariableNames;
+    }
+
+  }
+}
Index: /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/IDataGridContent.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/IDataGridContent.cs	(revision 13508)
+++ /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/IDataGridContent.cs	(revision 13508)
@@ -0,0 +1,39 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.DataPreprocessing {
+  public interface IDataGridContent : IStringConvertibleMatrix {
+    ITransactionalPreprocessingData PreProcessingData { get; }
+    ManipulationLogic ManipulationLogic { get; }
+    FilterLogic FilterLogic { get; }
+
+    IDictionary<int, IList<int>> Selection { get; set; }
+
+    void DeleteRows(IEnumerable<int> rows);
+    void DeleteColumn(int column);
+    bool Validate(string value, out string errorMessage, int columnIndex);
+
+    event DataPreprocessingChangedEventHandler Changed;
+  }
+}
Index: /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/IViewChartShortcut.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/IViewChartShortcut.cs	(revision 13508)
+++ /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/IViewChartShortcut.cs	(revision 13508)
@@ -0,0 +1,26 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+namespace HeuristicLab.DataPreprocessing {
+  public interface IViewChartShortcut : IViewShortcut {
+  }
+}
Index: /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/IViewShortcut.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/IViewShortcut.cs	(revision 13508)
+++ /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/IViewShortcut.cs	(revision 13508)
@@ -0,0 +1,27 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+
+namespace HeuristicLab.DataPreprocessing {
+  public interface IViewShortcut : IItem {
+  }
+}
Index: /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/LineChartContent.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/LineChartContent.cs	(revision 13508)
+++ /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/LineChartContent.cs	(revision 13508)
@@ -0,0 +1,46 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.DataPreprocessing {
+
+  [Item("LineChart", "Represents the line chart grid.")]
+  public class LineChartContent : PreprocessingChartContent {
+
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Performance; }
+    }
+
+    public LineChartContent(IFilteredPreprocessingData preprocessingData)
+      : base(preprocessingData) {
+    }
+
+    public LineChartContent(LineChartContent content, Cloner cloner)
+      : base(content, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new LineChartContent(this, cloner);
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/ManipulationContent.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/ManipulationContent.cs	(revision 13508)
+++ /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/ManipulationContent.cs	(revision 13508)
@@ -0,0 +1,57 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.DataPreprocessing {
+
+  [Item("Manipulation", "Represents the available manipulations on a data set.")]
+  public class ManipulationContent : Item, IViewShortcut {
+
+    private ManipulationLogic manipulationLogic;
+    private SearchLogic searchLogic;
+    private FilterLogic filterLogic;
+
+    public ManipulationLogic ManipulationLogic { get { return manipulationLogic; } }
+    public SearchLogic SearchLogic { get { return searchLogic; } }
+    public FilterLogic FilterLogic { get { return filterLogic; } }
+
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Method; }
+    }
+
+    public ManipulationContent(ManipulationLogic theManipulationLogic, SearchLogic theSearchLogic, FilterLogic theFilterLogic) {
+      manipulationLogic = theManipulationLogic;
+      searchLogic = theSearchLogic;
+      filterLogic = theFilterLogic;
+    }
+
+    public ManipulationContent(ManipulationContent content, Cloner cloner) : base(content, cloner) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ManipulationContent(this, cloner);
+    }
+
+
+  }
+}
Index: /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/PreprocessingChartContent.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/PreprocessingChartContent.cs	(revision 13508)
+++ /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/PreprocessingChartContent.cs	(revision 13508)
@@ -0,0 +1,143 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Drawing;
+using System.Linq;
+using HeuristicLab.Analysis;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.DataPreprocessing {
+  [Item("PreprocessingChart", "Represents a preprocessing chart.")]
+  public class PreprocessingChartContent : Item, IViewChartShortcut {
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.PieChart; }
+    }
+
+    private bool allInOneMode = true;
+    public bool AllInOneMode {
+      get { return this.allInOneMode; }
+      set { this.allInOneMode = value; }
+    }
+
+    private ICheckedItemList<StringValue> variableItemList = null;
+    public ICheckedItemList<StringValue> VariableItemList {
+      get { return this.variableItemList; }
+      set { this.variableItemList = value; }
+    }
+
+    public IFilteredPreprocessingData PreprocessingData { get; private set; }
+
+    public PreprocessingChartContent(IFilteredPreprocessingData preprocessingData) {
+      PreprocessingData = preprocessingData;
+    }
+
+    public PreprocessingChartContent(PreprocessingChartContent content, Cloner cloner)
+      : base(content, cloner) {
+      this.allInOneMode = content.allInOneMode;
+      this.PreprocessingData = content.PreprocessingData;
+      this.variableItemList = cloner.Clone<ICheckedItemList<StringValue>>(variableItemList);
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PreprocessingChartContent(this, cloner);
+    }
+
+
+    public DataRow CreateDataRow(string variableName, DataRowVisualProperties.DataRowChartType chartType) {
+      IList<double> values = PreprocessingData.GetValues<double>(PreprocessingData.GetColumnIndex(variableName));
+      DataRow row = new DataRow(variableName, "", values);
+      row.VisualProperties.ChartType = chartType;
+      return row;
+    }
+
+    public List<DataRow> CreateAllDataRows(DataRowVisualProperties.DataRowChartType chartType) {
+      List<DataRow> dataRows = new List<DataRow>();
+      foreach (var name in PreprocessingData.GetDoubleVariableNames())
+        dataRows.Add(CreateDataRow(name, chartType));
+      return dataRows;
+    }
+
+    public DataRow CreateSelectedDataRow(string variableName, DataRowVisualProperties.DataRowChartType chartType) {
+
+      IDictionary<int, IList<int>> selection = PreprocessingData.Selection;
+      int variableIndex = PreprocessingData.GetColumnIndex(variableName);
+
+      if (selection.Keys.Contains(variableIndex)) {
+        List<int> selectedIndices = new List<int>(selection[variableIndex]);
+        //need selection with more than 1 value
+        if (selectedIndices.Count < 2)
+          return null;
+
+        selectedIndices.Sort();
+        int start = selectedIndices[0];
+        int end = selectedIndices[selectedIndices.Count - 1];
+
+        DataRow rowSelect = CreateDataRowRange(variableName, start, end, chartType);
+        return rowSelect;
+      } else
+        return null;
+    }
+
+    public DataRow CreateDataRowRange(string variableName, int start, int end, DataRowVisualProperties.DataRowChartType chartType) {
+      IList<double> values = PreprocessingData.GetValues<double>(PreprocessingData.GetColumnIndex(variableName));
+      IList<double> valuesRange = new List<double>();
+      for (int i = 0; i < values.Count; i++) {
+        if (i >= start && i <= end)
+          valuesRange.Add(values[i]);
+        else
+          valuesRange.Add(Double.NaN);
+      }
+
+      DataRow row = new DataRow(variableName, "", valuesRange);
+      row.VisualProperties.ChartType = chartType;
+      return row;
+    }
+
+    public List<DataRow> CreateAllSelectedDataRows(DataRowVisualProperties.DataRowChartType chartType) {
+      List<DataRow> dataRows = new List<DataRow>();
+      foreach (var name in PreprocessingData.GetDoubleVariableNames()) {
+        DataRow row = CreateSelectedDataRow(name, chartType);
+        if (row != null)
+          dataRows.Add(row);
+      }
+      return dataRows;
+    }
+
+
+    public ICheckedItemList<StringValue> CreateVariableItemList(IEnumerable<string> checkedItems = null) {
+      ICheckedItemList<StringValue> itemList = new CheckedItemList<StringValue>();
+      foreach (string name in PreprocessingData.GetDoubleVariableNames()) {
+        var n = new StringValue(name);
+        itemList.Add(n, (checkedItems == null) ? true : checkedItems.Contains(name));
+      }
+      return new ReadOnlyCheckedItemList<StringValue>(itemList);
+    }
+
+    public event DataPreprocessingChangedEventHandler Changed {
+      add { PreprocessingData.Changed += value; }
+      remove { PreprocessingData.Changed -= value; }
+    }
+
+  }
+}
